<?php
// formcheck.inc.php for diaRice - photo calendar 0.3 en/de 07.09.2007 13:46
// Copyright (c) 2007 Michael Daum,  visit http://webdaum.de/

/***************************** Formcheck **************************************/


class formcheck extends login {

	var $msg;
	var $lang;
	var $field;
	
	function formcheck (
		$lang="en",
		$antispam=1,
		$max_hyperlinks=3,
		$check_email=1,
		$tags = array(
    	"b"=>B,
    	"i"=>I,
    	"u"=>U,
    	"cite"=>CITE,
    	"small"=>SMALL,
    	"big"=>BIG,
    	"br"=>BR,
    	"hr"=>HR,
    	"a"=>A
    )	
	) {
	

		foreach ($tags as $tag => $descr) {
			$tags[$tag] = str_replace($tag,"<$tag>",$tag);		
		}
		$tags = implode(",",$tags);
		
		if(!defined('FORMLANG')) define ("FORMLANG",$lang);
		
		$this->msg[FORMLANG] = "";
		
		if(!isset($this->msg[$lang])) {			 
			$this->msg[$lang] = &$this->msg['en'];
		}
		
		foreach (isset($_POST)?$_POST:$_GET as $key => $val) {
		
			 // cleanup string input:
			$this->field[$key] = $this->clean_up($val,true,$tags);
						
			// check required fields:
			if (strpos($key, "RE_")!== false && strlen($val)<1 || ($key === "text" && strlen($val)<1) ) {
				$this->msg[FORMLANG][$key]=DFN_FIELD." <strong>$key</strong>: ".MSG_IS_REQUIRED."!<br />\n";
			}
						
			// check ANTISPAM:
			if (isset($antispam) && strpos($key, "RE_code")!== false && $val!=$_POST["nr_1"]+$_POST["nr_2"]) {
				$this->msg[FORMLANG][$key]=DFN_FIELD." <strong>$key</strong>: ".MSG_IS_WRONG."!<br />\n";
			}						
			// check count hyperlimks:
			if (isset($antispam) && strpos($key, "text")!== false && substr_count($val,"http://")>$max_hyperlinks) {
				$this->msg[FORMLANG][$key]=DFN_FIELD." <strong>$key</strong>: ".MSG_IS_SPAM."<br />\n";
}
			// check for char "]" at the end of namefield:
			if (isset($antispam) && strpos(strtolower($key), "name")!== false && strrpos($val,"]")==strlen($val)-1) {
				$this->msg[FORMLANG][$key]=DFN_FIELD." <strong>$key</strong>: ".MSG_IS_STRANGE_NAME."!<br />\n";
			}
									
			// check namefield:
			if (strpos(strtolower($key), "user_name")!== false && strlen($val)<3) {
				$this->msg[FORMLANG][$key]=DFN_FIELD." <strong>$key</strong>: ".MSG_IS_NO_NAME."!<br />\n";
			}
			
			// check email:
			if ($check_email===1 && strpos(strtolower($key), "mail")!== false) {
				if (strlen($val)<3) {
					$this->msg[FORMLANG][$key]=DFN_FIELD." <strong>$key</strong>: ".MSG_IS_NO_EMAIL."!<br />\n";
				} else if(!ereg("^[_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@([a-zA-Z0-9-]+\.)+([a-zA-Z]{2,4})$",$val)){
					$this->msg[FORMLANG][$key]=DFN_FIELD." <strong>$key</strong>: ".MSG_IS_INVALID_EMAIL."!<br />\n";
				}
			}
			
			 // check for hacks:
			if($this->check_hack($val)!==false) {
				$this->msg[FORMLANG][$key]=$this->check_hack($val).DFN_IN_FIELD." <strong>$key</strong>: ".MSG_IS_FORBIDDEN."!<br />\n";
			}
			
			// autocomplete website:
			if (strpos(strtolower($key), "webs")!== false) {
				if(ereg("^([a-zA-Z0-9-]+\.)+([a-zA-Z]{2,4})$",$val)) {
				//http:// missing? autocomplete
					if(!ereg("^http:////",$val)){
						$this->field[$key]="http://$val";
					}
				}
			}
		}
	
	} // end parent constuct formcheck
	
	function msg ($lang=FORMLANG) {
	
		if($this->msg[$lang]!=="") {
			$out="";
			foreach ($this->msg[$lang] as $msg ) {
				$out.=$msg;
			}
			return $out;
		} else return false;
		
	} // end function msg
	
	function ok() {
	
		if($this->msg[FORMLANG]==="") {
			return true;
		} else return false;
		
	} // end function ok
	
	function check_hack ($input) {
	
		$_attack = false; // is set to "true" if hack detected
		$mail_hacks = array(
			"mime-version",
			"content-type",
			"to:",
			"cc:",
			"bcc:"
		);
		foreach($mail_hacks as $mail_hack) {
			$test = strpos(strtolower($input), strtolower($mail_hack));
			if($test!==false) {
				$_attack.= "$mail_hack ";
			}
		}
		return $_attack;
		
	} // end function check_hack

	
	// function IP-No-Reload:
	// Uses modified script Reloadsperre v1.0 by Matthias Kannengiesser
	function check_IP($min=1) {
	
		// check ip:
		$REMOTE_ADDR  = isset($REMOTE_ADDR)?$REMOTE_ADDR:$_SERVER["REMOTE_ADDR"];
		// IP-file
		$f_ip = _PATH."/data/ips.txt";
  	@$ip_array = file($f_ip);
    $reload_dat = fopen($f_ip,"w");
  	$this_time = time();
  	$found = 0;
  	for ($i=0; $i<count($ip_array); $i++) {
    	list($ip_addr,$time_stamp) = explode("|",$ip_array[$i]);
   	 if ($this_time < ($time_stamp+60*$min)) {
      	if ($ip_addr == $REMOTE_ADDR) {
        	$found=1;
        	$d =  ($time_stamp+60*$min)- $this_time;
					$this->msg[FORMLANG]['reload']= str_replace("%d",$d,MSG_RELOAD)."!<br />\n";	
      	}
      	else {
        	fwrite($reload_dat,"$ip_addr|$time_stamp");
      	}
    	}
  	}
  	fwrite($reload_dat,"$REMOTE_ADDR|$this_time\n");
  	fclose($reload_dat);

  	return ($found==1) ? 1 : 0;
	}
	
	function clean_up($inhalt, $strip_slashes=true, $tags) {

		if( is_array($inhalt)) {
			foreach($inhalt as $key => $item) {
				$inhalt[$key] = $this->clean_up($item, $strip_slashes);
			}
		} else if (!empty($inhalt)) {
		
			
			$inhalt = urldecode($inhalt);
			$inhalt = strip_tags($inhalt,$tags);
    	$inhalt = str_replace("", "&#8217;", $inhalt);
    	$inhalt = str_replace("`", "&#8217;", $inhalt);
    	$inhalt = str_replace("&nbsp;", "&#160;", $inhalt);
    	$inhalt = str_replace("'", "&#8217;", $inhalt);
			$inhalt = trim($inhalt);
    	$inhalt = str_replace("\f","",$inhalt);
    	$inhalt = str_replace("\r","",$inhalt);
    	#$inhalt = str_replace("\n","",$inhalt);
		
			if($strip_slashes) {
				$inhalt = stripslashes($inhalt);
				$inhalt = stripcslashes($inhalt);
			}
			
    	$inhalt = str_replace("<br>", "<br />", $inhalt);
    	$inhalt = str_replace("<hr>", "<hr />", $inhalt);
		}
		return $inhalt;
	}	// end function clean_up	
} // end class formcheck
?>